{***************************************************************************}
{                              UNIDAD DE RATON

                                  Copyright (c) 1998 Marco Antonio Alvarado

Obtiene la informacin actual del ratn y la almacena para que sea
disponible.

FALTA

* Escribir una rutina que inicialice el puerto del ratn para leer los datos
  sin instalar el manejador.}
{***************************************************************************}

UNIT URaton;

INTERFACE

  VAR
    ViejaAtiendeActiva : Boolean;

    CambioX,
    CambioY,
    X,
    Y : Integer;
    BotonIzquierdo,
    BotonDerecho : Boolean;

IMPLEMENTATION

  USES
    UDS;  {Unidad de DOS Services}

  CONST
{Valores de las interrupciones y los puertos seriales donde se puede conectar
el ratn:

        Interrupcin    Direccin
  COM1  $0c             $03f8
  COM2  $0b             $02f8
  COM3  $0c             $03e8
  COM4  $0b             $02e8}
    InterrupcionRaton = $0c;
    PuertoRaton = $03f8;

  VAR
    ViejaAtiende,
    ViejoExitProc : Pointer;
    Entrada,
    Cuenta : Byte;
    Entradas : ARRAY [0..2] OF Byte;

{$F+}
  PROCEDURE Atiende; INTERRUPT;
{$F-}
  BEGIN
{Recibe la seal del ratn en el puerto serial.}
    Entrada := Port [PuertoRaton];
{Ajusta la Cuenta.}
    IF (Entrada AND 64) = 64 THEN Cuenta := 0;
{Almacena las Entradas.}
    Entradas [Cuenta] := Entrada;

    IF Cuenta >= 2 THEN
    BEGIN
{Complet la informacin que requiere, ahora la traduce.}
      CambioX := (Entradas [0] AND 3) SHL 6 + Entradas [1];
      IF CambioX >= 128 THEN CambioX := CambioX - 256;
      X := X + CambioX;
      CambioY := (Entradas [0] AND 12) SHL 4 + Entradas [2];
      IF CambioY >= 128 THEN CambioY := CambioY - 256;
      Y := Y + CambioY;
      BotonIzquierdo := (Entradas [0] AND 32) <> 0;
      BotonDerecho := (Entradas [0] AND 16) <> 0;

{Recibir nueva infomacin.}
      Cuenta := 0;
    END else
    BEGIN
{Recibir ms informacin.}
      Inc (Cuenta);
    END;

    IF ViejaAtiendeActiva THEN
    ASM
      PUSHF
      CALL ViejaAtiende
    END ELSE
    BEGIN
      Port [$20] := $20;
    END;

  END;

{$F+}
  PROCEDURE Sale;
{$F-}
  BEGIN
    ExitProc := ViejoExitProc;

    PoneInterrupcion (InterrupcionRaton, ViejaAtiende);
  END;

BEGIN
  X := 0;
  Y := 0;
  BotonIzquierdo := False;
  BotonDerecho := False;
  Cuenta := 0;
  ViejaAtiendeActiva := False;
  ViejaAtiende := TomaInterrupcion (InterrupcionRaton);
  PoneInterrupcion (InterrupcionRaton, @Atiende);

  ViejoExitProc := ExitProc;
  ExitProc := @Sale;
END.